    PROGRAM
    INCLUDE('winequ.clw')

    ! http://msdn.microsoft.com/library/psdk/shellcc/shell/Functions/ShellExecute.htm

! You do not need the below equates but I included them incase you want to experiment
SW_HIDE             EQUATE(0) !Hides the window and activates another window.
SW_MAXIMIZE         EQUATE(3) !Maximizes the specified window.
SW_MINIMIZE         EQUATE(6) !Minimizes the specified window and activates the next top-level window in the z-order.
SW_RESTORE          EQUATE(9) !Activates and displays the window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when restoring a minimized window.
SW_SHOW             EQUATE(5) !Activates the window and displays it in its current size and position.
SW_SHOWDEFAULT      EQUATE(10) !Sets the show state based on the SW_ flag specified in the STARTUPINFO structure passed to the CreateProcess function by the program that started the application. An application should call ShowWindow with this flag to set the initial show state of its main window.
SW_SHOWMAXIMIZED    EQUATE(3) !Activates the window and displays it as a maximized window.
SW_SHOWMINIMIZED    EQUATE(2) !Activates the window and displays it as a minimized window.
SW_SHOWMINNOACTIVE  EQUATE(7) !Displays the window as a minimized window. The active window remains active.
SW_SHOWNA           EQUATE(8) !Displays the window in its current state. The active window remains active.
SW_SHOWNOACTIVATE   EQUATE(4) !Displays a window in its most recent size and position. The active window remains active.
SW_SHOWNORMAL       EQUATE(1) !Activates and displays a window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when displaying the window for the first time.

    MAP

        OpenURL(STRING Url)                         !My own function to encapsulate the call to SheelExecute
        SplashOpenURL(STRING Url)                   !Open a URL using the splash file


        MODULE('Windows')  !Windows 32-bit API
             GetDesktopWindow(),HWND,PASCAL
             ShellExecute(HWND       OwnWnd, |      !handle to Owner Window, use GetDesktopWindow()
                          <*CString  Verb>,  |      !Action: Omit for Open, else
                          *CString   ExFile, |      !File name to Execute, e.g. webrun.htm
                          <*CString  Parms>, |      !Command line parameters
                          <*CString  Dir>,   |      !Directory to start in
                          SIGNED ShowCmd)    |      !SW_SHOWxxx Show equate for window
                          ,HINSTANCE,PASCAL,RAW,PROC,NAME('ShellExecuteA')

           !  ShellExecute(HWND ,<*CString>, *CString, <*CString>, <*CString>,SIGNED)    |      !Shorter
           !               ,HINSTANCE,PASCAL,RAW,PROC,NAME('ShellExecuteA')


        END

    END

!HINSTANCE ShellExecute(
!    HWND hwnd, 
!    LPCTSTR lpVerb,   !omitted = open
!    LPCTSTR lpFile,   !URL
!    LPCTSTR lpParameters, 
!    LPCTSTR lpDirectory,
!    INT nShowCmd
!);
!
!    END


CustomUrl       STRING(255)
Url2Open        STRING(255)
SerialNo        STRING('12345     ')
Version         STRING('3.20      ')


Window WINDOW('WebSplash'),AT(,,298,168),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY,DOUBLE
       GROUP('Append Serial Number and Version Example'),AT(3,5,286,53),USE(?Group1),BOXED
         PROMPT('Serial &No'),AT(13,18),USE(?Prompt:SerialNo)
         ENTRY(@s10),AT(47,18,60,10),USE(SerialNo)
         PROMPT('&Version'),AT(13,36),USE(?Prompt:Version)
         ENTRY(@s10),AT(47,38,60,10),USE(Version)
         BUTTON('Make Custom File and &Open'),AT(127,26,91,14),USE(?SNExampleBtn)
       END
       GROUP('Open Any URL the Direct or Splash Way'),AT(3,68,288,62),USE(?Group2),BOXED
         PROMPT('&URL:'),AT(8,87),USE(?Prompt:URL)
         COMBO(@s255),AT(29,84,257,12),USE(Url2Open),DROP(10),FROM('www.carlbarnes.com/?sn=1234|www.clarionmag.com|www.softvelocity.com|http://msdn.microsoft.com/library/psdk/shellcc/shell/Functions/ShellExecute.htm|http://internet-tips.net/HTML/META_httpequiv_refresh.htm')
         BUTTON('Web &Splash'),AT(69,106,65,14),USE(?WebSplashBtn)
         BUTTON('Execute &Directly'),AT(153,106,65,14),USE(?DirectBtn),TIP('ShellExecute the URL')
       END
       BUTTON('Close'),AT(116,140,65,14),USE(?CloseBtn),STD(Std:Close)
     END

    CODE

    Url2Open = 'www.clarionmag.com'
    OPEN(Window)
    ACCEPT
        CASE ACCEPTED()
        OF ?SNExampleBtn
           CustomUrl=CLIP(GETINI('URL','BaseURL','','.\SplashCB.HTM')) & '?SN=' & CLIP(SerialNo) &'&Ver=' & CLIP(Version)
           PUTINI('URL', 'URL',  CustomUrl,'.\SplashCB.HTM')
           PUTINI('HREF','href', CustomUrl,'.\SplashCB.HTM')
           OpenURL('SplashCB.HTM')

        OF ?WebSplashBtn
           SplashOpenURL(Url2Open)

        OF ?DirectBtn
           OpenURL(Url2Open)
        END
    END


OpenURL         PROCEDURE(STRING Url)
ShellFile         CSTRING(256)
            CODE
    ShellFile = CLIP(Url)
    ShellExecute(GetDesktopWindow(),,ShellFile,,,SW_SHOW)  ! SW_SHOW EQUATE(5)


SplashOpenURL   PROCEDURE(STRING Url)       !setup the Splashww.HTM file to call any URL
HttpURL           STRING(256)
Ques              LONG,AUTO
            CODE

    IF INSTRING('://',Url,1)                !--URL's in HTML files must have the protocol e.g. http:// or ftp:// etc
       HttpURL = URL
    ELSE
       HttpURL = 'http://' & URL
    END

    Ques=INSTRING('?',Url) - 1              !--If the URL has Parms (www.me.com.?dhdh=229) then leave those off the visible link
    IF Ques < 1 THEN Ques=LEN(CLIP(Url)).
    ASSERT(EXISTS('Splashww.HTM'),'No Splashww.HTM')
    PUTINI('URL', 'URL',  HttpURL,'.\Splashww.HTM')                                 !The reditect Link
    PUTINI('HREF','href', CLIP(HttpURL) &'>'& SUB(URL,1,Ques),'.\Splashww.HTM')     !The clickable link
    OpenURL('Splashww.HTM')

